function [z] = rootfinder(x,y)
// A GUI for finding the roots of transcendental equation using Numerical Methods.
//
// Syntax
//   rootfinder() 
//
// Description
// rootfinder() creates a graphical user interface (GUI) for finding the roots of equations, using numerical methods. 
// 
// <itemizedlist>
// <listitem><para>A user can select the method for finding the root using the dropdown menu. It currently offers Bisection method (default), False-Position method, Newton Raphson method and Secant method.</para></listitem>
// <listitem><para>In next step user can enter the function or equation</para></listitem>
// <listitem><para>A useful feature of this toolbox is that if you don't know the interval for finding the roots, you can just press the Find Interval button and it will show you the interval for finding the roots and by selecting the interval it will automatically filled in the initial guess edit boxes. </para></listitem>
// <listitem><para>If you don't want to select the interval from the list, you can also manually type the values of intial guess. </para></listitem>
// <listitem><para>After that you have to select the stopping criteria for the root finding method, and enter the tolerance value </para></listitem>
// <listitem><para>After providing all the input,you can press the solution button, and it will show you the root and a table containing all the relevent data. </para></listitem>
// <listitem><para>You can also plot the equation to double check the roots. </para></listitem>
// </itemizedlist>
//
// Examples
// rootfinder()
//
// See also
//  roots
//
// Authors
//  Manish Joshi ;  
//
z = sin(x).*cos(x + y);
endfunction
