// --------------------------------------------------
// COPYRIGHT © 2021 - AUTHOR - MANISH JOSHI
//
// CREATED USING SCILAB-6.1.0 ON WINDOWS-10 64-bit
//
// DATE OF CREATION: 30 Jun, 2021 
// --------------------------------------------------


// CALLBACK FOR SOLUTION BUTTON.
function RFG_BSolution(RFG)
	if RFG.Function.string == '' then
		messagebox('Please enter the function f(x)','error','error');
	elseif RFG.FirstGuess.string == '' 
		if RFG.Choose.value ==3
			messagebox('Please enter the derivative of f(x): f''(x)','error','error');
		else
			messagebox('Please enter a valid initial guess', 'error','error');
		end
	elseif ~isnum(RFG.SecondGuess.string)
		messagebox('Please enter a valid initial guess','error','error');
	elseif ~isnum(RFG.Error.string)
		messagebox('Please enter a valid tolerance value','error','error');
	elseif RFG.Choose.value ~=3 & ~isnum(RFG.FirstGuess.string)
		messagebox('Please enter a valid initial guess','error','error');
    else
		Pbar=progressionbar('Calculating....');
		progressionbar(Pbar);
		if RFG.Choose.value ==1 then
			deff('y=f(x)', 'y = ' + convstr(RFG.Function.string, 'l'));
			a = evstr(RFG.FirstGuess.string);
			b = evstr(RFG.SecondGuess.string);
			tol  = evstr(RFG.Error.string)
			if RFG.ErrorType.value == 1
				RFG_Bisection(RFG, f, a, b, tol, 'abs(b-a)');
			elseif RFG.ErrorType.value == 2
				RFG_Bisection(RFG, f, a, b, tol, 'abs((b-a)/b)');
			elseif RFG.ErrorType.value == 3
				RFG_Bisection(RFG, f, a, b, tol, 'abs((b-a)/b)*100');
			elseif RFG.ErrorType.value == 4
				RFG_Bisection(RFG, f, a, b, tol, 'abs(f(c))');
			else 
				error('Wrong Choice');
			end
		elseif RFG.Choose.value == 2
			deff('y=f(x)', 'y = ' + convstr(RFG.Function.string, 'l'));
			a = evstr(RFG.FirstGuess.string);
			b = evstr(RFG.SecondGuess.string);
			tol  = evstr(RFG.Error.string)
			if RFG.ErrorType.value == 1
				RFG_FalsePM(RFG,f,a,b,tol,['abs(c-a)','abs(c-a)']);
			elseif RFG.ErrorType.value == 2
				RFG_FalsePM(RFG, f, a, b, tol, ['abs((c-a)/c)','abs((c-a)/c)']);
			elseif RFG.ErrorType.value == 3
				RFG_FalsePM(RFG, f, a, b, tol, ['abs((c-a)/c)*100','abs((c-a)/c)*100']);
			elseif RFG.ErrorType.value == 4
				RFG_FalsePM(RFG, f, a, b, tol, ['abs(f(c))', 'abs(f(c))']);
			else 
				error('Wrong Choice');
			end
		elseif RFG.Choose.value == 3
			deff('y=f(x)', 'y = ' + convstr(RFG.Function.string, 'l'));
			deff('dy=df(x)', 'dy = ' + convstr(RFG.FirstGuess.string, 'l'));
			a = evstr(RFG.SecondGuess.string);
			tol  = evstr(RFG.Error.string);
			if RFG.ErrorType.value == 1
				RFG_NRaphson(RFG, f, df, a, tol, 'abs((a-c))');
			elseif RFG.ErrorType.value == 2
				RFG_NRaphson(RFG, f, df, a, tol, 'abs((c-a)/c)');
			elseif RFG.ErrorType.value == 3
				RFG_NRaphson(RFG, f, df, a, tol, 'abs((c-a)/c)*100');
			elseif RFG.ErrorType.value == 4
				RFG_NRaphson(RFG, f, df, a, tol, 'abs(f(c))');
			else 
				error('Wrong Choice');
			end
		elseif RFG.Choose.value == 4
			deff('y=f(x)', 'y = ' + convstr(RFG.Function.string, 'l'));
			a = evstr(RFG.FirstGuess.string);
			b = evstr(RFG.SecondGuess.string);
			tol  = evstr(RFG.Error.string)
			if RFG.ErrorType.value == 1
				RFG_SecantM(RFG, f, a,b, tol, 'abs(f(c))');
			elseif RFG.ErrorType.value == 2
				RFG_SecantM(RFG, f, a,b, tol, 'abs((c-b))');
			else 
				error('Wrong Choice');
			end
		end
		close(Pbar);
	end
endfunction
