// --------------------------------------------------
// COPYRIGHT © 2021 - AUTHOR - MANISH JOSHI
//
// CREATED USING SCILAB-6.1.0 ON WINDOWS-10 64-bit
//
// DATE OF CREATION: 30 Jun, 2021 
// --------------------------------------------------


// FUNCTION FOR BISECTION METHOD.
function [c, err, fc] = RFG_Bisection(RFG, f, a, b, tol, etype)
	fa = feval(a,f); fb = feval(b,f);

	if fa == 0
		c = a; err = 0; fc = 0;
		RFG.Root.string = msprintf("Root = %0.16g , error =  %0.10g\n",c,err);
	RFG.MaxItr.string = msprintf("Total Iteration : %d ",0);
		return;
	elseif fb == 0
		c = b; err = 0; fc =0;
		RFG.Root.string = msprintf("Root = %0.16g , error =  %0.10g\n",c,err);
	RFG.MaxItr.string = msprintf("Total Iteration : %d ",0);
		return;
	elseif fa*fb>0
		msg = msprintf(" roots may or may not exist in this interval [a, b] \n f(a) = %f \t f(b) = %f", fa,fb)
		messagebox(msg,'Error',"error");
		c=%nan; err=%nan, fc=%nan;
		return; 
	end

	//maxitr = 1 + round((log(abs(b-a))-log(abs(tol)))/log(2));
	//RFG.MaxItr.string = msprintf("Max. Number of Iteration needed : %d ",maxitr)
	Table(1,:)=['itr','a','b','f(a)','f(b)','c','f(c)','error'];
	i = 1; n=1; maxitr = 2000;
	while 1
		c = (a+b)/2;
		fc = feval(c,f);
		err = evstr(etype)
		Table(i+1,:)=[string(i),string(a),string(b),string(f(a)),string(f(b)),string(c),string(f(c)),string(err)];
		if evstr(etype)<= abs(tol)  then
			break;
		end
		if fc == 0
			err =0; Table(i+1,$)= string(err);
			break;
		elseif fa*fc<0
			b=c;
		else
			a=c;
		end
		i = i+1;
		if (i>n*maxitr)
			msg  = msprintf("Convergence not achived after  %d itterations \n Do you want to continue",n*maxitr)
			if (messagebox( msg, "modal", "info", ["Yes" "No"])==2)
				break;
			else
				n=n+1;
			end
			
		end
	end
	RFG.OutputTable.string = Table;
	RFG.Root.string = msprintf("Root = %0.16g , error =  %0.10g\n",c,err);
	RFG.MaxItr.string = msprintf("Number of Iteration needed : %d ",i)
endfunction
