// --------------------------------------------------
// COPYRIGHT © 2021 - AUTHOR - MANISH JOSHI
//
// CREATED USING SCILAB-6.1.0 ON WINDOWS-10 64-bit
//
// DATE OF CREATION: 30 Jun, 2021 
// --------------------------------------------------


// FUNCTION FOR NEWTON RAPHSON METHOD.
function [c, err, fc] = RFG_NRaphson(RFG,f,df, a, tol,etype)
	if df(a) == 0 then
		messagebox("f''(a) = 0 please enter a different initial guess a",'error','Error');
	elseif f(a) == 0
		c = a; err = 0; fc = 0;
		RFG.Root.string = msprintf("Root = %0.16g , error =  %0.10g\n",c,err);
	RFG.MaxItr.string = msprintf("Total Iteration : %d, initial guess a is the root",0);
		return;
	else
		i = 0;
		maxitr = 2000; n = 1;
		Table(1,:)=['itr','a','f(a)','f''(a)','c','f(c)','error'];
		while (1)
			i = i+1;
			c = a - f(a)/df(a);
			if f(c) == 0
				err = 0
				Table(i+1,:)=[string(i),string(a),string(f(a)),string(df(a)),string(c),string(f(c)),string(err)];
				break; 
				end
			err = evstr(etype);
			Table(i+1,:)=[string(i),string(a),string(f(a)),string(df(a)),string(c),string(f(c)),string(err)];
			a = c;
			if err < abs(tol)
				break;
			end
			if (i>n*maxitr)
				msg  = msprintf("Convergence not achived after  %d itterations \n Do you want to continue",n*maxitr)
				if (messagebox( msg, "modal", "info", ["Yes" "No"])==2)
					break;
				else
					n=n+1;
				end	
			end
			if isnan(f(c))| isnan(c)| isinf(f(c))| isinf(c) 
			messagebox("Sorry we can not reach to desire accuracy",'error','error')
			break;
		end
		end
		RFG.OutputTable.string = Table;
		RFG.Root.string = msprintf("Root = %0.16g , error =  %0.10g\n",c,err);
		RFG.MaxItr.string = msprintf("Total Iteration : %d ",i)
	end
endfunction
