// --------------------------------------------------
// COPYRIGHT © 2021 - AUTHOR - MANISH JOSHI
//
// CREATED USING SCILAB-6.1.0 ON WINDOWS-10 64-bit
//
// DATE OF CREATION: 30 Jun, 2021 
// --------------------------------------------------


// FUNCTION FOR SECANT METHOD.
function [c, err, fc] = RFG_SecantM(RFG,f,a,b,tol,etype)
	maxitr = 2000; n=1;
	fa = feval(a,f); fb = feval(b,f);
	if fa == 0
		c = a; err = 0; fc = 0;
		RFG.Root.string = msprintf("Root = %0.16g , error =  %0.10g\n",c,err);
	RFG.MaxItr.string = msprintf("Total Iteration : %d, End point a is the root",0);
		return;
	elseif fb == 0
		c = b; err = 0; fc =0;
		RFG.Root.string = msprintf("Root = %0.16g , error =  %0.10g\n",c,err);
	RFG.MaxItr.string = msprintf("Total Iteration : %d, End point b is the root",0);
		return;
	end
	Table(1,:)=['itr','a','b','f(a)','f(b)','c','f(c)','error'];
	i = 0;
	err = abs(b-a)
	while (1)
		c = (f(b)*a - f(a)*b)/(f(b)-f(a));
		fc = feval(c,f);
		err = evstr(etype);
		i = i+1;
		Table(i+1,:)=[string(i),string(a),string(b),string(f(a)),string(f(b)),string(c),string(f(c)),string(err)];
		a = b;
		b = c;
		if fc == 0
			err =0; Table(i+1,$)= string(err);
			break;
		end
		if  err <= tol
			break;
		end
		if (i>n*maxitr)
			msg  = msprintf("Convergence not achived after  %d itterations \n Do you want to continue",n*maxitr)
			if (messagebox( msg, "modal", "info", ["Yes" "No"])==2)
				break;
			else
				n=n+1;
			end
			
		end
		if isnan(fc)| isnan(c)| isinf(fc)| isinf(c) 
			messagebox("Sorry we can not reach to desire accuracy",'error','error')
			break;
		end
	end
	RFG.OutputTable.string = Table;
	RFG.Root.string = msprintf("Root = %0.16g , error =  %0.10g\n",c,err);
	RFG.MaxItr.string = msprintf("Total Iteration : %d ",i);
endfunction
