// --------------------------------------------------
// COPYRIGHT © 2021 - AUTHOR - MANISH JOSHI
//
// CREATED USING SCILAB-6.1.0 ON WINDOWS-10 64-bit
//
// DATE OF CREATION: 30 Jun, 2021 
// --------------------------------------------------

function rootfinder()
	// FIGURE
	f=figure('figure_position',[-3,0],'figure_size',[1546,871],'auto_resize','on','background',[-2],'figure_name','Root Finding GUI','dockable','off','infobar_visible','on','toolbar_visible','off','menubar_visible','off','default_axes','off','visible','off');
	f.icon = "applications-system";
	f.info_message = "Bisection method has the important property that it always converges to a solution, and for that"+ascii(10)+"reason it is often used as a starter for the more efficient methods. But it is slow to converge"
	//////////
	RFG.dummy = 0;
	RFG.Title=uicontrol(f,'unit','normalized','BackgroundColor',[0.4,0.5,0.7],'Enable','on','FontAngle','normal','FontName','Arial Nova Cond Light','FontSize',[20],'FontUnits','points','FontWeight','bold','ForegroundColor',[1,1,1],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0,0.95,1,0.05],'Relief','ridge','SliderStep',[0.01,0.1],'String','Root Finder','Style','text','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','Title','Callback','')
	RFG.BottomTitle=uicontrol(f,'unit','normalized','BackgroundColor',[-1,-1,-1],'Enable','on','FontAngle','normal','FontName','Arial Nova Cond Light','FontSize',[15],'FontUnits','points','FontWeight','bold','ForegroundColor',[0.2,0.5,0.1],'HorizontalAlignment','left','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0,0,0.5,0.05],'Relief','ridge','SliderStep',[0.01,0.1],'String','         Created by - Manish Joshi','Style','text','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','BottomTitle','Callback','')
	RFG.website=uicontrol(f,'unit','normalized','BackgroundColor',[-1,-1,-1],'Enable','on','FontAngle','normal','FontName','Arial Nova Cond Light','FontSize',[15],'FontUnits','points','FontWeight','bold','ForegroundColor',[0.2,0.3,0.6],'HorizontalAlignment','right','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.5,0,0.5,0.05],'Relief','ridge','SliderStep',[0.01,0.1],'String', "<html><a href=""https://atoms.scilab.org/toolboxes/RFG_Toolbox"">Please Give Your Suggestion or Report Bugs </a> &nbsp&nbsp&nbsp&nbsp&nbsp&nbsp</html>",'Style','text','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','website','Callback','')
	RFG.ChooseMethod=uicontrol(f,'unit','normalized','BackgroundColor',[-1,-1,-1],'Enable','on','FontAngle','normal','FontName','Arial Nova Cond Light','FontSize',[15],'FontUnits','points','FontWeight','bold','ForegroundColor',[-1,-1,-1],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0,0.9,0.2,0.05],'Relief','ridge','SliderStep',[0.01,0.1],'String','Select Method :','Style','text','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','ChooseMethod','Callback','')
	RFG.Choose=uicontrol(f,'unit','normalized','BackgroundColor',[-1,-1,-1],'Enable','on','FontAngle','normal','FontName','Arial Nova Cond Light','FontSize',[15],'FontUnits','points','FontWeight','bold','ForegroundColor',[-1,-1,-1],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.2,0.905,0.3,0.045],'Relief','ridge','SliderStep',[0.01,0.1],'String',['    Bisection','    False Position','    Newton Raphson','    Secant'],'Style','popupmenu','Value',[1],'VerticalAlignment','middle','Visible','on','Tag','Choose','Callback','RFG_Choose_callback(RFG,f)','TooltipString','Select method')
	RFG.BFrame=uicontrol(f,'unit','normalized','BackgroundColor',[-1,-1,-1],'Enable','on','FontAngle','normal','FontName','Arial Nova Cond Light','FontSize',[15],'FontUnits','points','FontWeight','normal','ForegroundColor',[-1,-1,-1],'HorizontalAlignment','left','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0,0.05,0.5,0.86],'Relief','sunken','SliderStep',[0.01,0.1],'String','UnName6','Style','frame','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','BFrame','Callback','')
	RFG.PlotFrame=uicontrol(f,'unit','normalized','BackgroundColor',[-1,-1,-1],'Enable','on','FontAngle','normal','FontName','Arial Nova Cond Light','FontSize',[15],'FontUnits','points','FontWeight','normal','ForegroundColor',[-1,-1,-1],'HorizontalAlignment','left','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.5,0.05,0.5,0.90],'Relief','sunken','SliderStep',[0.01,0.1],'String','UnName6','Style','frame','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','BFrame','Callback','')
	RFG.Plot= newaxes(RFG.PlotFrame);RFG.Plot.margins = [ 0 0 0 0];RFG.Plot.axes_bounds = [0.1,0.05,0.85,0.87]; RFG.Plot.thickness = 2;RFG.Plot.font_size = 3;RFG.Plot.font_color = 11;RFG.Plot.font_style=10;RFG.Plot.auto_clear = "on";
	RFG.InputFrame=uicontrol(RFG.BFrame,'unit','normalized','BackgroundColor',[-1,-1,-1],'Enable','on','FontAngle','normal','FontName','Arial Nova Cond Light','FontSize',[15],'FontUnits','points','FontWeight','normal','ForegroundColor',[-1,-1,-1],'HorizontalAlignment','left','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.05,0.65,0.9,0.3],'Relief','sunken','SliderStep',[0.01,0.1],'String','','Style','frame','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','InputFrame','Callback','')
	RFG.ResultFrame=uicontrol(RFG.BFrame,'unit','normalized','BackgroundColor',[-1,-1,-1],'Enable','on','FontAngle','normal','FontName','Arial Nova Cond Light','FontSize',[15],'FontUnits','points','FontWeight','normal','ForegroundColor',[-1,-1,-1],'HorizontalAlignment','left','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.05,0.55,0.9,0.075],'Relief','sunken','SliderStep',[0.01,0.1],'String','','Style','frame','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','InputFrame','Callback','')
	RFG.OutputTable=uicontrol(RFG.BFrame,'unit','normalized','BackgroundColor',[-1,-1,-1],'Enable','on','FontAngle','normal','FontName','Arial Nova Cond Light','FontSize',[15],'FontUnits','points','FontWeight','bold','ForegroundColor',[-1,-1,-1],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.025,0.025,0.925,0.5],'Relief','sunken','SliderStep',[0.01,0.1],'String','','Style','table','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','OutputTable','Callback','')
	RFG.FunctionLabel=uicontrol(RFG.InputFrame,'unit','normalized','BackgroundColor',[-1,-1,-1],'Enable','on','FontAngle','normal','FontName','Arial Nova Cond Light','FontSize',[15],'FontUnits','points','FontWeight','bold','ForegroundColor',[-1,-1,-1],'HorizontalAlignment','right','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.02,0.8,0.15,0.15],'Relief','default','SliderStep',[0.01,0.1],'String','f(x) :  ','Style','text','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','functionL','Callback','','TooltipString','Please enter the function')
	RFG.Function=uicontrol(RFG.InputFrame,'unit','normalized','BackgroundColor',[-1,-1,-1],'Enable','on','FontAngle','normal','FontName','Arial Nova Cond Light','FontSize',[15],'FontUnits','points','FontWeight','bold','ForegroundColor',[-1,-1,-1],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.22,0.8,0.50,0.15],'Relief','groove','SliderStep',[0.01,0.1],'String','','Style','edit','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','function','Callback','')
	
	RFG.FindInterval=uicontrol(RFG.InputFrame,'unit','normalized','BackgroundColor',[-1,-1,-1],'Enable','on','FontAngle','normal','FontName','Arial Nova Cond Light','FontSize',[15],'FontUnits','points','FontWeight','bold','ForegroundColor',[-1,-1,-1],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.725,0.8,0.225,0.15],'Relief','groove','SliderStep',[0.01,0.1],'String','Find Interval','Style','pushbutton','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','a','Callback','RFG_FindInterval(RFG)')
	RFG.FirstGuessLabel=uicontrol(RFG.InputFrame,'unit','normalized','BackgroundColor',[-1,-1,-1],'Enable','on','FontAngle','normal','FontName','Arial Nova Cond Light','FontSize',[15],'FontUnits','points','FontWeight','bold','ForegroundColor',[-1,-1,-1],'HorizontalAlignment','right','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.02,0.6,0.15,0.15],'Relief','default','SliderStep',[0.01,0.1],'String','a :  ','Style','text','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','aL','Callback','')
	RFG.FirstGuess=uicontrol(RFG.InputFrame,'unit','normalized','BackgroundColor',[-1,-1,-1],'Enable','on','FontAngle','normal','FontName','Arial Nova Cond Light','FontSize',[15],'FontUnits','points','FontWeight','bold','ForegroundColor',[-1,-1,-1],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.22,0.6,0.33,0.15],'Relief','groove','SliderStep',[0.01,0.1],'String','','Style','edit','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','a','Callback','')
	RFG.SecondGuessLabel=uicontrol(RFG.InputFrame,'unit','normalized','BackgroundColor',[-1,-1,-1],'Enable','on','FontAngle','normal','FontName','Arial Nova Cond Light','FontSize',[15],'FontUnits','points','FontWeight','bold','ForegroundColor',[-1,-1,-1],'HorizontalAlignment','right','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.55,0.6,0.15,0.15],'Relief','default','SliderStep',[0.01,0.1],'String','b :  ','Style','text','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','aL','Callback','')
	RFG.SecondGuess=uicontrol(RFG.InputFrame,'unit','normalized','BackgroundColor',[-1,-1,-1],'Enable','on','FontAngle','normal','FontName','Arial Nova Cond Light','FontSize',[15],'FontUnits','points','FontWeight','bold','ForegroundColor',[-1,-1,-1],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.725,0.6,0.225,0.15],'Relief','groove','SliderStep',[0.01,0.1],'String','','Style','edit','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','a','Callback','')
	RFG.ErrorTypeLabel=uicontrol(RFG.InputFrame,'unit','normalized','BackgroundColor',[-1,-1,-1],'Enable','on','FontAngle','normal','FontName','Arial Nova Cond Light','FontSize',[15],'FontUnits','points','FontWeight','bold','ForegroundColor',[-1,-1,-1],'HorizontalAlignment','right','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.02,0.4,0.15,0.15],'Relief','default','SliderStep',[0.01,0.1],'String','Error Type : ','Style','text','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','aL','Callback','')
	RFG.ErrorType=uicontrol(RFG.InputFrame,'unit','normalized','BackgroundColor',[-1,-1,-1],'Enable','on','FontAngle','normal','FontName','Arial Nova Cond Light','FontSize',[15],'FontUnits','points','FontWeight','bold','ForegroundColor',[-1,-1,-1],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.22,0.1,0.33,0.45],'Relief','groove','SliderStep',[0.01,0.1],'String',['<html><label>   &nbsp&nbsp | b - a |</label></html>' ,'<html><font size=""1"" ><table align=""center"" cellspacing=""0"" cellpadding=""0"" border=""0""><tr><td>&nbsp&nbsp | b -a |</td></tr><tr><td><hr width=""80%""></td></tr><tr><td>&nbsp&nbsp&nbsp&nbsp| b |</td></tr></table></html>','<html><font size=""1"" ><table align=""center"" cellspacing=""0"" cellpadding=""0"" border=""0""><tr><td>&nbsp&nbsp| b - a |</td></tr><tr><td><hr width=""80%""></td><td> X 100</td></tr><tr><td>&nbsp&nbsp&nbsp&nbsp| b |</td></tr></table></html>','    | f(c) |'],'Style','popupmenu','Value',[4],'VerticalAlignment','middle','Visible','on','Tag','a','Callback','')
	RFG.ErrorLabel=uicontrol(RFG.InputFrame,'unit','normalized','BackgroundColor',[-1,-1,-1],'Enable','on','FontAngle','normal','FontName','Arial Nova Cond Light','FontSize',[12],'FontUnits','points','FontWeight','bold','ForegroundColor',[-1,-1,-1],'HorizontalAlignment','right','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.55,0.4,0.15,0.15],'Relief','default','SliderStep',[0.01,0.1],'String','$\mathsf{\textbf{\leq Tol:}}$','Style','text','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','aL','Callback','')
	RFG.Error=uicontrol(RFG.InputFrame,'unit','normalized','BackgroundColor',[-1,-1,-1],'Enable','on','FontAngle','normal','FontName','Arial Nova Cond Light','FontSize',[15],'FontUnits','points','FontWeight','bold','ForegroundColor',[-1,-1,-1],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.725,0.4,0.225,0.15],'Relief','groove','SliderStep',[0.01,0.1],'String','1e-6','Style','edit','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','a','Callback','')
	RFG.SoluBtn=uicontrol(RFG.InputFrame,'unit','normalized','BackgroundColor',[-1,-1,-1],'Enable','on','FontAngle','normal','FontName','Arial Nova Cond Light','FontSize',[15],'FontUnits','points','FontWeight','bold','ForegroundColor',[-1,-1,-1],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.80,0.1,0.15,0.175],'Relief','raised','SliderStep',[0.01,0.1],'String','Solution','Style','pushbutton','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','solbtn','Callback','RFG_BSolution(RFG)')
	RFG.PlotBtn=uicontrol(RFG.InputFrame,'unit','normalized','BackgroundColor',[-1,-1,-1],'Enable','on','FontAngle','normal','FontName','Arial Nova Cond Light','FontSize',[15],'FontUnits','points','FontWeight','bold','ForegroundColor',[-1,-1,-1],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.60,0.1,0.15,0.175],'Relief','raised','SliderStep',[0.01,0.1],'String','Plot','Style','pushbutton','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','plotbtn','Callback','RFG_RootPlot(RFG)') 
	RFG.MaxItr= uicontrol(RFG.ResultFrame,'unit','normalized','BackgroundColor',[-1,-1,-1],'Enable','on','FontAngle','normal','FontName','Arial Nova Cond Light','FontSize',[15],'FontUnits','points','FontWeight','bold','ForegroundColor',[-1,-1,-1],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.05,0.55,0.9,0.4],'Relief','default','SliderStep',[0.01,0.1],'String','','Style','text','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','aL','Callback','')
	RFG.Root= uicontrol(RFG.ResultFrame,'unit','normalized','BackgroundColor',[-1,-1,-1],'Enable','on','FontAngle','normal','FontName','Arial Nova Cond Light','FontSize',[15],'FontUnits','points','FontWeight','bold','ForegroundColor',[-1,-1,-1],'HorizontalAlignment','center','ListboxTop',[],'Max',[1],'Min',[0],'Position',[0.05,0.05,0.9,0.4],'Relief','default','SliderStep',[0.01,0.1],'String','','Style','text','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','aL','Callback','')
	f.visible = "on";
	f.resizefcn = 'deff(''resiz()'', '''')';
	[f,RFG]=resume(f,RFG)
endfunction

